# Prepare wordlists
F := FreeGroup("x", "y");
f1 := GeneratorsOfMagma(F)[1];
x := GeneratorsOfMagma(F)[3];
y := GeneratorsOfMagma(F)[5];

listwords := function (xorder, yorder, maxmoleculelength, stopafter,
                     enumfunction, atomprodsonly)
             
    local current, i, j, atomlist, numatoms, word,
          finished, wordnum, carryon;
    
    current := [];
    atomlist := [];
    wordnum := 0;
    
    for i in [1..xorder-1] do
        for j in [1..yorder-1] do
            Add(atomlist, x^i*y^j);
        od;
    od;
    
    numatoms := Length(atomlist);
    
    for i in [1..maxmoleculelength] do
        current[i] := 0;
    od;
    
    if atomprodsonly then
        for i in [1..xorder-1] do
            wordnum := wordnum + 1;
            enumfunction(x^i, wordnum);
        od;
        for j in [1..yorder-1] do
            wordnum := wordnum + 1;
            enumfunction(y^j, wordnum);
        od;
    fi;
    
    finished := false;
    repeat
        word := f1;
        for i in [1..maxmoleculelength] do
            if (current[i] > 0) then
                word := word * atomlist[current[i]];
            fi;
        od;
        if atomprodsonly then
            wordnum := wordnum + 1;
            carryon := enumfunction(word, wordnum);
            if not carryon or
               (stopafter > 0 and wordnum = stopafter)
               then
                return;
            fi;
        else
            for i in [0..xorder-1] do
                for j in [0..yorder-1] do
                    wordnum := wordnum + 1;
                    carryon := enumfunction(y^j*word*x^i, wordnum);
                    if not carryon or
                       (stopafter > 0 and wordnum = stopafter)
                       then
                        return;
                    fi;
                od;
            od;
        fi;
        for i in [1..maxmoleculelength] do
            if (current[i] < numatoms) then
                current[i] := current[i] + 1;
                break;
            else
                if (i = maxmoleculelength) then
                    finished := true;
                    break;
                else
                    current[i] := 1;
                fi;
            fi;
        od;
    until finished;
    
end;
